#pragma once

#include <string>
#include <vector>
#include <map>
#include "J3ML/LinearAlgebra/Matrix4x4.h"
#include <assimp/Importer.hpp>
#include <LearnOpenGL/Model.h>
#include <LearnOpenGL/Bone.h>
#include <LearnOpenGL/BoneInfo.h>

namespace LearnOpenGL
{
    class Animation
    {
    public:
        Animation() = default;

        Animation(const std::string& animationPath, Model* model);


        ~Animation();
        Bone* FindBone(const std::string& name);

        inline float GetTicksPerSecond() { return TicksPerSecond; }
        inline float GetDuration() { return Duration; }
        inline const AssimpNodeData& GetRootNode() { return RootNode; }
        inline const std::map<std::string, BoneInfo>& GetBoneIDMap()
        {
            return BoneInfoMap;
        }

        float Duration;
        int TicksPerSecond;
        std::vector<Bone> Bones;
        AssimpNodeData RootNode;
        std::map<std::string, BoneInfo> BoneInfoMap;

    private:
        void ReadMissingBones(const aiAnimation* animation, Model& model);

        Matrix4x4 OMFGConvert(aiMatrix4x4)
        {

        }

        void ReadHierarchyData(AssimpNodeData& dest, const aiNode* src);
    };
}